<template>
  <div class="col-12">
    <div class="d-flex justify-content-between">
      <h5 class="mb-5">List User</h5>
      <div>
        <router-link :to="{name: 'Adduser'}"
          class="btn btn-success">+ Tambah User
        </router-link>
      </div>
    </div>
    <div class="table-responsive">
      <table class="table">
        <thead>
          <tr>
            <th>No</th>
            <th scope="col">ID</th>
            <th scope="col">Email</th>
            <th scope="col">First Name</th>
            <th scope="col">Last Name</th>
            <th scope="col">Avatar</th>
            <th scope="col">Action</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) in getList" :key="index" class="link" style="cursor:pointer;">
            <td>{{ pagingNumber(index + 1) }}</td>
            <th scope="row" @click="view(item.url)">{{ item.id }}</th>
            <td @click="view(item.id)">{{ item.email }}</td>
            <td @click="view(item.id)">{{ item.first_name }}</td>
            <td @click="view(item.id)">{{ item.last_name }}</td>
            <td @click="view(item.id)">
              <img :src="item.avatar" style="width: 15%;">
            </td>
            <td class="d-flex">
              <router-link :to="{name: 'Updateuser', params: { id: item.id }}"
              class="d-flex align-items-center mr-5">
                <i class="material-icons">edit</i>
              </router-link>
              <i class="material-icons" style="cursor:pointer;" @click="delet(item.id)">delete_outline</i>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <b-pagination
      v-model="currentPage"
      :total-rows="rows"
      :per-page="perPage"
      aria-controls="my-table">
    </b-pagination>
    <template>
      <div class="Aligner" style="display:none;">
        <b-modal ref="my-modal" hide-footer>
          <div class="d-block">
            <h5 class="mb-4 text-center">Detail</h5>
            <div class="d-flex mb-2">
              <img :src="foto" alt="" class="col-5">
              <div class="col-2">
                <div>ID</div>
                <div>Email</div>
                <div>First Name</div>
                <div>Last Name</div>
              </div>
              <div class="col-5">
                <div>: {{ id }}</div>
                <div>: {{ email }}</div>
                <div>: {{ first_name }}</div>
                <div>: {{ last_name }}</div>
              </div>
            </div>
          </div>
        </b-modal>
      </div>
    </template>
    <template>
      <div class="Aligner" style="display:none;">
        <b-modal ref="warning" hide-footer>
          <div class="d-block form-input text-center">
            <h5 class="mb-4 text-left" style="color:#959595;"><b>ID User : {{ id }}</b></h5>
            <h5 style="color:#959595;">Are you Sure?</h5>
            <div class="d-flex justify-content-center">
              <button class="btn btn-secondary mr-2" @click="tidak">No</button>
              <button class="btn btn-success" @click="proses">Yes</button>
            </div>
          </div>
        </b-modal>
      </div>
    </template>
     <template>
      <div class="Aligner" style="display:none;">
        <b-modal ref="sukses" hide-footer>
          <div class="d-block text-center">
            <h5>Data is deleted</h5>
          </div>
        </b-modal>
      </div>
    </template>
  </div>
</template>

<script>
export default {
  name: 'Dashboard',
  data () {
    return {
      getList: [],
      id: '',
      name: '',
      email: '',
      first_name: '',
      last_name: '',
      foto: '',
      perPage: null,
      currentPage: 1,
      rows: null
    }
  },
  watch: {
    currentPage (pageNumber) {
      this.dataget(pageNumber)
    }
  },
  mounted () {
    this.dataget()
  },
  methods: {
    dataget () {
      this.getPageData('https://reqres.in/api/users?page=' + this.currentPage)
    },
    getPageData (url) {
      this.axios.get(url, {
        headers: {
          accept: 'application/json',
          'Content-Type': 'multipart/form-data, text/plain'
        }
      })
        .then(response => {
          let res = response.data
          this.getList = res.data
          this.perPage = res.per_page
          this.currentPage = res.page
          this.rows = res.total
          this.numberValue = 0
          if (this.currentPage === 1) {
            this.numberValue = 0
            this.perNoAwal = 1
            this.perNoAkhir = 10
          } else {
            this.numberValue = (res.per_page * this.currentPage) - res.per_page
          }
        })
    },
    delet (id) {
      let detail = this.getList.find((data) => {
        return data.id === id
      })
      this.id = detail.id
      this.$refs['warning'].show()
    },
    tidak () {
      this.$refs['warning'].hide()
    },
    proses () {
      this.$refs['warning'].hide()
      this.axios.delete('https://reqres.in/api/users/' + this.id, null, {
        headers: {
        }
      })
        .then(response => {
          this.$refs['sukses'].show()
          setTimeout(() => {
            this.$router.go({ name: 'Starships' })
          }, 1000)
        })
    },
    view (value) {
      this.$refs['my-modal'].show()
      this.axios.get('https://reqres.in/api/users/' + value, {
        headers: {
        }
      })
        .then(response => {
          this.id = value
          let res = response.data
          this.email = res.data.email
          this.first_name = res.data.first_name
          this.last_name = res.data.last_name
          this.foto = res.data.avatar
        })
    },
    pagingNumber (index) {
      return index + this.numberValue
    }
  }
}
</script>

<style lang="scss">
.pointer {
  cursor: pointer;
}
.pointer:hover {
  background-color: #fff;
  color: #fff !important;
}
.modal-dialog {
  max-width: 800px;
  margin: 1.75rem auto;
}
.link:hover {
  background: rgba(4, 141, 113, 1);
  color: #ffffff;
}
.link:hover td {
  color: #ffffff !important;
}
a:hover {
  color: #ffffff;
  text-decoration: underline;
}
.pagination {
  margin-bottom: 1rem;
  -webkit-box-pack: end;
  -ms-flex-pack: end;
  justify-content: flex-end;
  margin-top: 1.5rem;
}
</style>
